codeforces 250C Movie Critics

题目:大意是说



Valentine在想要去看电影,总共n场电影,每场电影都有一个对应的genre值x  (1?<=x?<=k),但是



Valentine不想把所有的电影都看完,他想把其中某些genre值=x的电影去掉,只看剩下的电影,但是还有一个问题:就是每场电影的时间是固定的,所以他必须按顺序来观看,当上一场电影的genre值与下一场的genre值不一样的时候,



Valentine的愤怒值就会+1(初始为0),题目要求出去掉genre值为x的电影后,他的愤怒值最小的x。

方法:仔细想了一下之后会发现,需要使用暴力把1-K之间的值遍历一下,求出所有的愤怒值,但是数据量太大,这样肯定会超时,所以就观察一下,如果不去掉任何电影,那么假设他的愤怒值为Y,去掉后为y,那么就是让我们求Y-y的值最大的那个x。让我们来看一个例子:1 3 2,假设要去掉的x=3,根据题目的描述,去掉3后两边的电影值还是不同,所以这样他的总愤怒值Y应该-1,下一个例子:1 3 1,同样去掉3之后,发现两边的电影值相同,那么他的愤怒值应该-2。这样我们就了解了这道题的解决方法。

优化:题目中会出现例如:1 3 3 2的例子,也就是去掉3的时候,还要去掉它后面与它值相同的电影,这样就不如在加载数据的时候把数据直接改为1 3 2,这样会减少很多麻烦。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
int main()
{
     int n,k,x,t=1,s[100010],d[100010];
     memset(d,0,sizeof(d));
     cin>>n>>k;
     s[0]=0;
      for(int i=1;i<=n;i++)
       {
           cin>>x;
           if(x!=s[t-1]) s[t++]=x;
       }
       s[0]=s[t]=0;
     for(int i=1;i<t;i++)
     {
         if(s[i-1]==s[i+1]) d[s[i]]+=2;
         else d[s[i]]+=1;
     }
     int p=1;
     for(int i=2;i<=k;i++)
        if(d[i]>d[p]) p=i;
     cout<<p<<endl;
    return 0;
}

codeforces 250C Movie Critics,码迷,mamicode.com

时间: 2024-11-08 08:53:23

codeforces 250C Movie Critics的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ